
/* file to declare variables for action selection functions */
/* asm_mydecs is for including (sheesh!) still need a copy of decs somewhere */

#ifdef __cplusplus
extern "C" {
#endif

  /* My new c++ stuff.... */
  void em_initialize();
  int em_select_action();
     

/* the animal's action chosen by the strategy */
extern int action;

/* the function choosing the strategy */
extern int select_action();

/* properties of current situation of environment */
extern double fat_minus,
	  carbo_minus,
	  protein_minus,
	  water_minus,
	  an_temp_minus,
	  an_temp_plus,
	  sqr_temp_minus,
	  sqr_temp_plus,
	  mate_courtedness,
	  cleanliness,
	  night_prox,
	  variance,
	  den_distance;

/* it seems like the animal ought to have some idea how healthy it is.*/
/* this doesn't get passed into the asm stuff, am I cheating? ;-) JB */
extern double animal_health;

/* arrays of values (over all directions) of all stimuli that are direction
dependent */
extern double *food_perc_stim,
	   *food_memory_stim,
	   *water_perc_stim,
	   *water_memory_stim,
	   *shelter_perc_stim,
	   *shade_perc_stim,
	   *p1_perc_stim,
	   *p2_perc_stim,
	   *dp_perc_stim,
	   *irr_perc_stim,
	   *mate_perc_stim,
	   *den_perc_stim,
	   *den_memory_stim,
	   *edge_perc_stim;

/* maximum values (over all directions) of all stimuli that are direction
dependent */
extern double max_food_perc_stimulus,
	   max_food_memory_stimulus,
	   max_water_perc_stimulus,
	   max_water_memory_stimulus,
	   max_shelter_perc_stimulus,
	   max_shade_perc_stimulus,
	   max_p1_perc_stimulus,
	   max_p2_perc_stimulus,
	   max_dp_perc_stimulus,
	   max_irr_perc_stimulus,
	   max_mate_perc_stimulus,
	   max_den_perc_stimulus,
	   max_den_memory_stimulus,
	   max_edge_perc_stimulus;

/* directions of closest instances of different features from animal */
extern int food_dir;
extern int remembered_food_dir;
extern int water_dir;
extern int remembered_water_dir;
extern int shelter_dir;
extern int shade_dir;
extern int p1_dir;
extern int p2_dir;
extern int dp_dir;
extern int irr_dir;
extern int mate_dir;
extern int den_dir;
extern int remembered_den_dir;
extern int edge_dir;

void get_maxs_and_dirs();

/* `boolean' variables indicating which sort of food is in animal's square*/
extern int prey_in_animal_square,
		   cf_in_animal_square,
		   ff_in_animal_square;


/* utility functions enabling certain types of behaviour */
void approach(),
	 avoid(),
	 run_away_from(),
	 explore(),
	 look_in_direction();


#ifdef __cplusplus
}
#endif

